// $ANTLR 2.7.7 (20080607): "vinl_walker.g" -> "VinlAstWalker.java"$

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

	import java.io.*;
	import java.util.*;
	import java.awt.*;


public class VinlAstWalker extends antlr.TreeParser       implements VinlAstWalkerTokenTypes
 {

	static Hashtable<String, VinlFunction> function_table = new Hashtable();
	static VinlSymbolTable global_table = new VinlSymbolTable();
	static VinlSymbolTable curr_table = global_table;
	static Hashtable<String, String> keywords = new Hashtable();
	static VinlGraphicPanel gp;
	static VinlTurtle turtle;
	VinlType ret = null; // used in function return
	
	/* control flows */
	boolean inloop = false;
	boolean breaked = false;
	boolean continued = false;
	boolean proceed = true; 
	boolean returned = false;

	/* DEBUG LEVEL */
	public static final int INFO = 3;
	public static final int DEBUG = 2;
	public static final int DEBUG_FINE = 1;

	public static int curr_level = 4; //no messages

	static {
		/* vinl keywords should not be used as identifiers.
		   Should also forbid java keywords, however java keywords are not VINL limitation,
		   so I will left it for Java compiler to catch such error.
		*/
		keywords.put("backward", "backward");	
		keywords.put("bw", "bw");	
		keywords.put("boolean", "boolean");	
		keywords.put("break", "break");	
		keywords.put("cl", "cl");	
		keywords.put("clear", "clear");	
		keywords.put("continue", "continue");	
		keywords.put("decimal", "decimal");	
		keywords.put("echo", "echo");	
		keywords.put("for", "for");	
		keywords.put("forward", "forward");	
		keywords.put("funct", "funct");	
		keywords.put("fw", "fw");	
		keywords.put("home", "home");	
		keywords.put("if", "if");	
		keywords.put("left", "left");	
		keywords.put("lt", "lt");	
		keywords.put("pendown", "pendown");	
		keywords.put("pd", "pd");	
		keywords.put("penup", "penup");	
		keywords.put("pu", "pu");	
		keywords.put("right", "right");	
		keywords.put("rt", "rt");	
		keywords.put("var", "var");	
		keywords.put("void", "void");	
		
		gp = VinlInterpreterGui.getGraphicPanel();	
	}
	
	boolean isKeyword(String name) {
		return keywords.containsKey(name);
	}	

	static void log(String s, int level)  {
		if(level > curr_level) 
		{		
			System.out.println(s);
		}
	}
public VinlAstWalker() {
	tokenNames = _tokenNames;
}

	public final  VinlType  expr(AST _t) throws RecognitionException {
		 VinlType r ;
		
		AST expr_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST stmt = null;
		AST right_or = null;
		AST right_and = null;
		AST type = null;
		AST id = null;
		AST var_id = null;
		AST decimal = null;
		AST ifbody = null;
		AST elsebody = null;
		AST while_condition = null;
		AST while_body = null;
		AST for_condition = null;
		AST post_action = null;
		AST for_body = null;
		AST func_name = null;
		AST func_body = null;
		
			VinlType a, b;
			r=null;
			turtle = gp.getTurtle();
			String[] func_params;
			VinlType[] expr_list;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STATEMENT:
			{
				AST __t2 = _t;
				AST tmp1_AST_in = (AST)_t;
				match(_t,STATEMENT);
				_t = _t.getFirstChild();
				{
				_loop4:
				do {
					if (_t==null) _t=ASTNULL;
					if (((_t.getType() >= ALPHA && _t.getType() <= LITERAL_var))) {
						stmt = (AST)_t;
						if ( _t==null ) throw new MismatchedTokenException();
						_t = _t.getNextSibling();
						r=expr(stmt);
					}
					else {
						break _loop4;
					}
					
				} while (true);
				}
				_t = __t2;
				_t = _t.getNextSibling();
				break;
			}
			case PLUS:
			{
				AST __t5 = _t;
				AST tmp2_AST_in = (AST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t5;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.PLUS, a, b);
				break;
			}
			case MINUS:
			{
				AST __t6 = _t;
				AST tmp3_AST_in = (AST)_t;
				match(_t,MINUS);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t6;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.MINUS, a, b);
				break;
			}
			case MULT:
			{
				AST __t7 = _t;
				AST tmp4_AST_in = (AST)_t;
				match(_t,MULT);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t7;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.MULTI, a, b);
				break;
			}
			case DIV:
			{
				AST __t8 = _t;
				AST tmp5_AST_in = (AST)_t;
				match(_t,DIV);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t8;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.DIV, a, b);
				break;
			}
			case MOD:
			{
				AST __t9 = _t;
				AST tmp6_AST_in = (AST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t9;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.MOD, a, b);
				break;
			}
			case LT:
			{
				AST __t10 = _t;
				AST tmp7_AST_in = (AST)_t;
				match(_t,LT);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t10;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.LT, a, b);
				break;
			}
			case GT:
			{
				AST __t11 = _t;
				AST tmp8_AST_in = (AST)_t;
				match(_t,GT);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t11;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.GT, a, b);
				break;
			}
			case GE:
			{
				AST __t12 = _t;
				AST tmp9_AST_in = (AST)_t;
				match(_t,GE);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t12;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.GE, a, b);
				break;
			}
			case EQ:
			{
				AST __t13 = _t;
				AST tmp10_AST_in = (AST)_t;
				match(_t,EQ);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t13;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.EQ, a, b);
				break;
			}
			case NEQ:
			{
				AST __t14 = _t;
				AST tmp11_AST_in = (AST)_t;
				match(_t,NEQ);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t14;
				_t = _t.getNextSibling();
				if(proceed) r=a.eval(VinlOperation.NEQ, a, b);
				break;
			}
			case OR:
			{
				AST __t15 = _t;
				AST tmp12_AST_in = (AST)_t;
				match(_t,OR);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				right_or = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				_t = __t15;
				_t = _t.getNextSibling();
					/* short circuit or */
							if(proceed) 
							{
								if (a instanceof VinlBoolean)
									r=((VinlBoolean) a).getValue()?new VinlBoolean(true):expr(right_or);
							}
						
				break;
			}
			case AND:
			{
				AST __t16 = _t;
				AST tmp13_AST_in = (AST)_t;
				match(_t,AND);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				right_and = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				_t = __t16;
				_t = _t.getNextSibling();
				
							/* short circuit and */
							if(proceed) 
							{
								if (a instanceof VinlBoolean)
									r=((VinlBoolean) a).getValue()?expr(right_and):new VinlBoolean(false);
							}
						
				break;
			}
			case ASSIGN:
			{
				AST __t17 = _t;
				AST tmp14_AST_in = (AST)_t;
				match(_t,ASSIGN);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				b=expr(_t);
				_t = _retTree;
				_t = __t17;
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								if(curr_table.get(a.getName())==null) 
								{
									throw new RecognitionException("ERROR: Could not find variable: "+a.getName());
								} else {
									if(a instanceof VinlBoolean && b instanceof VinlBoolean) 
									{
										((VinlBoolean) a).setValue(((VinlBoolean) b).getValue());
									}
									else if (a instanceof VinlDecimal && b instanceof VinlDecimal) 
									{
										((VinlDecimal) a).setValue(((VinlDecimal) b).getValue());
									} 
									else 
									{
										log("Type of variable: "+((a==null)?"null":a.getType())+ ", type of rvalue: "+((b==null)?"null":b.getType()), INFO);
										throw new RecognitionException("ERROR: Type mismatched assignment.");		
									}
								}
							}
						
				break;
			}
			case LITERAL_true:
			{
				AST tmp15_AST_in = (AST)_t;
				match(_t,LITERAL_true);
				_t = _t.getNextSibling();
				if(proceed) r=new VinlBoolean(true);
				break;
			}
			case LITERAL_false:
			{
				AST tmp16_AST_in = (AST)_t;
				match(_t,LITERAL_false);
				_t = _t.getNextSibling();
				if(proceed) r=new VinlBoolean(false);
				break;
			}
			case LITERAL_void:
			{
				AST tmp17_AST_in = (AST)_t;
				match(_t,LITERAL_void);
				_t = _t.getNextSibling();
				if(proceed) r = new VinlVoid();
				break;
			}
			case LITERAL_clear:
			{
				AST tmp18_AST_in = (AST)_t;
				match(_t,LITERAL_clear);
				_t = _t.getNextSibling();
				if(proceed) gp.clearScreen();
				break;
			}
			case LITERAL_cl:
			{
				AST tmp19_AST_in = (AST)_t;
				match(_t,LITERAL_cl);
				_t = _t.getNextSibling();
				if(proceed) gp.clearScreen();
				break;
			}
			case LITERAL_home:
			{
				AST tmp20_AST_in = (AST)_t;
				match(_t,LITERAL_home);
				_t = _t.getNextSibling();
				if(proceed) gp.homeTurtle();
				break;
			}
			case LITERAL_penup:
			{
				AST tmp21_AST_in = (AST)_t;
				match(_t,LITERAL_penup);
				_t = _t.getNextSibling();
				if(proceed) turtle.setPenDown(false);
				break;
			}
			case LITERAL_pu:
			{
				AST tmp22_AST_in = (AST)_t;
				match(_t,LITERAL_pu);
				_t = _t.getNextSibling();
				if(proceed) turtle.setPenDown(false);
				break;
			}
			case LITERAL_pendown:
			{
				AST tmp23_AST_in = (AST)_t;
				match(_t,LITERAL_pendown);
				_t = _t.getNextSibling();
				if(proceed) turtle.setPenDown(true);
				break;
			}
			case LITERAL_pd:
			{
				AST tmp24_AST_in = (AST)_t;
				match(_t,LITERAL_pd);
				_t = _t.getNextSibling();
				if(proceed) turtle.setPenDown(true);
				break;
			}
			case LITERAL_break:
			{
				AST tmp25_AST_in = (AST)_t;
				match(_t,LITERAL_break);
				_t = _t.getNextSibling();
				
							if(proceed) 
							{ 
								if(inloop) 
								{	
									proceed = false; 
									breaked = true; 
									log("break further stmts", DEBUG);
								} 
								else 
									throw new RecognitionException("ERROR: Illegal break out side of any while/for loop");
							} 
						
				break;
			}
			case LITERAL_continue:
			{
				AST tmp26_AST_in = (AST)_t;
				match(_t,LITERAL_continue);
				_t = _t.getNextSibling();
				
							if(proceed) 
							{	
								if(inloop) 
								{ 
									proceed = false; 
									continued = true; 
									log("Stop further stmts", DEBUG);
								}
								else 
									throw new RecognitionException("ERROR: Illegal break out side of any while/for loop");
							} 
						
				break;
			}
			case LITERAL_var:
			{
				AST __t18 = _t;
				AST tmp27_AST_in = (AST)_t;
				match(_t,LITERAL_var);
				_t = _t.getFirstChild();
				type = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				id = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				_t = __t18;
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								if(isKeyword(id.getText())) 
									throw new RecognitionException("ERROR: Illegal use of keyword *"+id.getText()+"*");
				
								if(type.getText().equals("decimal")) 
								{
									r = new VinlDecimal(id.getText());
									curr_table.put(id.getText(), r);		
								} 
								else if (type.getText().equals("boolean")) 
								{
									r = new VinlBoolean(id.getText());
									curr_table.put(id.getText(), r);		
								} 
								else 
								{
									throw new RecognitionException("ERROR: Unrecognized type specified.");
								}
							}
						
				break;
			}
			case ID:
			{
				var_id = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								if(curr_table.get(var_id.getText())!=null)  
									r=curr_table.get(var_id.getText());
								else
									throw new RecognitionException("ERROR: Undeclared variable: "+var_id.getText());
							}
						
				break;
			}
			case DECIMAL:
			{
				decimal = (AST)_t;
				match(_t,DECIMAL);
				_t = _t.getNextSibling();
				if(proceed) r=new VinlDecimal(Double.parseDouble(decimal.getText()));
				break;
			}
			case LITERAL_echo:
			{
				AST __t19 = _t;
				AST tmp28_AST_in = (AST)_t;
				match(_t,LITERAL_echo);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t19;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								String value="";
								if(a instanceof VinlBoolean) 
									value += ((VinlBoolean)a).getValue();
								else if(a instanceof VinlDecimal) 
									value += ((VinlDecimal)a).getValue();
								else if(a instanceof VinlFunction) 
									value += "a function";
								else
									value="not valid"; 
								log("The rvalue is: "+value, curr_level+1); //always print 
							}
						
				break;
			}
			case LITERAL_forward:
			{
				AST __t20 = _t;
				AST tmp29_AST_in = (AST)_t;
				match(_t,LITERAL_forward);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t20;
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								log("Going forward: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.forward(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_fw:
			{
				AST __t21 = _t;
				AST tmp30_AST_in = (AST)_t;
				match(_t,LITERAL_fw);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t21;
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								log("Going forward: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.forward(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_backward:
			{
				AST __t22 = _t;
				AST tmp31_AST_in = (AST)_t;
				match(_t,LITERAL_backward);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t22;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								log("Going backward: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.backward(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_bw:
			{
				AST __t23 = _t;
				AST tmp32_AST_in = (AST)_t;
				match(_t,LITERAL_bw);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t23;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								log("Going backward: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.backward(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_left:
			{
				AST __t24 = _t;
				AST tmp33_AST_in = (AST)_t;
				match(_t,LITERAL_left);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t24;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								log("Turn left: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.left(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_lf:
			{
				AST __t25 = _t;
				AST tmp34_AST_in = (AST)_t;
				match(_t,LITERAL_lf);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t25;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								log("Turn left: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.left(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_right:
			{
				AST __t26 = _t;
				AST tmp35_AST_in = (AST)_t;
				match(_t,LITERAL_right);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t26;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								log("Turn right: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.right(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_rt:
			{
				AST __t27 = _t;
				AST tmp36_AST_in = (AST)_t;
				match(_t,LITERAL_rt);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				_t = __t27;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								log("Turn right: "+((VinlDecimal)a).getValue(), DEBUG_FINE); 
								gp.right(((VinlDecimal)a).getValue());
							}
						
				break;
			}
			case LITERAL_if:
			{
				AST __t28 = _t;
				AST tmp37_AST_in = (AST)_t;
				match(_t,LITERAL_if);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				ifbody = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case ALPHA:
				case DIGIT:
				case WS:
				case EOL:
				case COMMENT:
				case LPAREN:
				case RPAREN:
				case MULT:
				case DIV:
				case MOD:
				case PLUS:
				case MINUS:
				case SEMI:
				case LBRACE:
				case RBRACE:
				case ASSIGN:
				case COMMA:
				case EQ:
				case NEQ:
				case GT:
				case GE:
				case LT:
				case LE:
				case AND:
				case OR:
				case ID:
				case DECIMAL:
				case STATEMENT:
				case FUNC_CALL:
				case EXPR_LIST:
				case PARAMS_LIST:
				case FUNC_BODY:
				case LITERAL_exit:
				case LITERAL_bye:
				case LITERAL_quit:
				case LITERAL_if:
				case LITERAL_else:
				case LITERAL_while:
				case LITERAL_for:
				case LITERAL_break:
				case LITERAL_continue:
				case LITERAL_return:
				case LITERAL_pendown:
				case LITERAL_pd:
				case LITERAL_penup:
				case LITERAL_pu:
				case LITERAL_home:
				case LITERAL_forward:
				case LITERAL_fw:
				case LITERAL_backward:
				case LITERAL_bw:
				case LITERAL_right:
				case LITERAL_rt:
				case LITERAL_left:
				case LITERAL_lf:
				case LITERAL_echo:
				case LITERAL_clear:
				case LITERAL_cl:
				case LITERAL_status:
				case LITERAL_decimal:
				case LITERAL_boolean:
				case LITERAL_void:
				case LITERAL_funct:
				case LITERAL_true:
				case LITERAL_false:
				case LITERAL_var:
				{
					elsebody = (AST)_t;
					if ( _t==null ) throw new MismatchedTokenException();
					_t = _t.getNextSibling();
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t28;
				_t = _t.getNextSibling();
				
							if(proceed)
							{
								if(a instanceof VinlBoolean) 
								{
									if(((VinlBoolean)a).getValue()) { 
										//do if part
										r = expr(ifbody);
									}
									else 
									{
										//do else part
										r = expr(elsebody);
									}
								} 
								else
								{
									throw new RecognitionException("ERROR: Only accept boolean express as if condition");
								} 
							}
						
				break;
			}
			case LITERAL_return:
			{
				AST __t30 = _t;
				AST tmp38_AST_in = (AST)_t;
				match(_t,LITERAL_return);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case MULT:
				case DIV:
				case MOD:
				case PLUS:
				case MINUS:
				case ASSIGN:
				case EQ:
				case NEQ:
				case GT:
				case GE:
				case LT:
				case AND:
				case OR:
				case ID:
				case DECIMAL:
				case STATEMENT:
				case FUNC_CALL:
				case LITERAL_if:
				case LITERAL_while:
				case LITERAL_for:
				case LITERAL_break:
				case LITERAL_continue:
				case LITERAL_return:
				case LITERAL_pendown:
				case LITERAL_pd:
				case LITERAL_penup:
				case LITERAL_pu:
				case LITERAL_home:
				case LITERAL_forward:
				case LITERAL_fw:
				case LITERAL_backward:
				case LITERAL_bw:
				case LITERAL_right:
				case LITERAL_rt:
				case LITERAL_left:
				case LITERAL_lf:
				case LITERAL_echo:
				case LITERAL_clear:
				case LITERAL_cl:
				case LITERAL_status:
				case LITERAL_void:
				case LITERAL_funct:
				case LITERAL_true:
				case LITERAL_false:
				case LITERAL_var:
				{
					a=expr(_t);
					_t = _retTree;
					if(proceed) { ret = a; r = a; }
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t30;
				_t = _t.getNextSibling();
				
							/* if returned, it's same as breaked in the sense no stmt should run anymore */
							proceed = false;
							returned = true;
						
				break;
			}
			case LITERAL_while:
			{
				AST __t32 = _t;
				AST tmp39_AST_in = (AST)_t;
				match(_t,LITERAL_while);
				_t = _t.getFirstChild();
				while_condition = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				while_body = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				_t = __t32;
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								inloop = true;
								VinlType while_cond = expr(while_condition);	
								if(!(while_cond instanceof VinlBoolean)) 
									throw new RecognitionException("ERROR: Condition in for/while loop must be boolean type");
								while(((VinlBoolean)while_cond).getValue()) 
								{
									r = expr(while_body);
									if(breaked) 
									{
										//reset break for future statements
										proceed = true;
										breaked = false;
										break;
									}
									else if(continued) 
									{
										proceed=true;
										continued=false;
									}
									while_cond=expr(while_condition);
								}
								inloop = false;	
							}
						
				break;
			}
			case LITERAL_for:
			{
				AST __t33 = _t;
				AST tmp40_AST_in = (AST)_t;
				match(_t,LITERAL_for);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				for_condition = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				post_action = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				for_body = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				_t = __t33;
				_t = _t.getNextSibling();
				
							if(proceed) 
							{
								inloop = true;
								VinlType for_cond = expr(for_condition);
								if(!(for_cond instanceof VinlBoolean))
									throw new RecognitionException("ERROR: Condition in for/while loop must be boolean type");
								while(((VinlBoolean)for_cond).getValue()) 
								{
									r = expr(for_body);
									if(breaked) 
									{
										//reset break for future statements
										proceed = true;
										breaked = false;
										break;
									}
									else if(continued) 
									{
										proceed=true;
										continued=false;
									}
									r = expr(post_action);
									for_cond=expr(for_condition);
								}
								inloop = false;	
							}	
						
				break;
			}
			case LITERAL_status:
			{
				AST tmp41_AST_in = (AST)_t;
				match(_t,LITERAL_status);
				_t = _t.getNextSibling();
				
							/* printout internal states*/
							log(String.format("Control flows: proceed=(%s), inloop=(%s), breaked=(%s), continued=(%s), returned=(%s)", proceed, inloop, breaked, continued, returned), curr_level+1);
							log(String.format("turtle coordinates: x=%f y=%f angle(in degree)=%f", turtle.getX(), turtle.getY(), turtle.getAngle()), curr_level+1);
						
				break;
			}
			case FUNC_CALL:
			{
				AST __t34 = _t;
				AST tmp42_AST_in = (AST)_t;
				match(_t,FUNC_CALL);
				_t = _t.getFirstChild();
				a=expr(_t);
				_t = _retTree;
				expr_list=mexpr(_t);
				_t = _retTree;
				_t = __t34;
				_t = _t.getNextSibling();
				
							if(proceed) {
								if(!(a instanceof VinlFunction))
									throw new RecognitionException("ERROR: "+a.getName()+" is not a function.");
								
								VinlFunction func = (VinlFunction) a;
								/* every function starts its own scope with current scope as it's parent scope */
								log("Current symbol table: " + curr_table, DEBUG_FINE);
								func.getSymTable().setParent(curr_table);
								curr_table = func.getSymTable();
								log("New symbol table, going to functions: "+func.getName()+"'s scope: " + curr_table, DEBUG_FINE);
								/* evaluate arguments and put them in symbol table */	
								String[] params = func.getParams();
								int j = 0; //expr_list index
								for(int i = 0; i<params.length; i++) {
									if(params[i].equals("void")) {
										if(expr_list[j]==null || !(expr_list[j] instanceof VinlVoid)) 
											throw new RecognitionException("ERROR: Wrong argument passed to function at index: "+j);
									} else if (params[i].equals("decimal") && params[++i] != null) {
										if(expr_list[j]==null || !(expr_list[j] instanceof VinlDecimal)) 
											throw new RecognitionException("ERROR: Wrong argument passed to function at index: "+j);
										log("putting "+params[i]+" in sym table",DEBUG_FINE);
										((VinlDecimal)expr_list[j]).setName(params[i]);
										curr_table.put(params[i], expr_list[j++]); 
									} else if (params[i].equals("boolean") && params[++i] != null) {
										if(expr_list[j]==null || !(expr_list[j] instanceof VinlBoolean)) 
											throw new RecognitionException("ERROR: Wrong argument passed to function at index: "+j);
										log("putting "+params[i]+" in sym table",DEBUG_FINE);
										((VinlBoolean)expr_list[j]).setName(params[i]);
										curr_table.put(params[i], expr_list[j++]); 
									}
								}
								/* invoke this function */	
								r=expr(func.getBody());
								if(returned) {
									proceed = true; 
									returned = false;
									if(ret != null) {
										r = ret;
									}
									ret = null;
								}
								/* coming out of the function so resume parent scope now */
								log("Out of function: "+func.getName()+"'s scope: " + curr_table, DEBUG_FINE);
								curr_table = curr_table.getParent();
								log("Back to "+func.getName()+"'s parent scope: " + curr_table, DEBUG_FINE);
								/* destory the function symbol table */
								func.setSymTable(new VinlSymbolTable());
							}
						
				break;
			}
			case LITERAL_funct:
			{
				AST __t35 = _t;
				AST tmp43_AST_in = (AST)_t;
				match(_t,LITERAL_funct);
				_t = _t.getFirstChild();
				func_name = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				func_params=vlist(_t);
				_t = _retTree;
				func_body = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
				_t = __t35;
				_t = _t.getNextSibling();
				
							r = new VinlFunction(func_name.getText(), func_params, func_body);
							curr_table.put(func_name.getText(), r);
						
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r ;
	}
	
	public final  VinlType[]  mexpr(AST _t) throws RecognitionException {
		 VinlType[] mret ;
		
		AST mexpr_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
			ArrayList<VinlType> list = new ArrayList();
			mret = null;
			VinlType a;
		
		
		try {      // for error handling
			AST __t37 = _t;
			AST tmp44_AST_in = (AST)_t;
			match(_t,EXPR_LIST);
			_t = _t.getFirstChild();
			{
			int _cnt39=0;
			_loop39:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					a=expr(_t);
					_t = _retTree;
					list.add(a);
				}
				else {
					if ( _cnt39>=1 ) { break _loop39; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt39++;
			} while (true);
			}
			_t = __t37;
			_t = _t.getNextSibling();
			
						mret = new VinlType[list.size()];
						mret = list.toArray(mret); 
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return mret ;
	}
	
	public final  String[]  vlist(AST _t) throws RecognitionException {
		 String[] ret ;
		
		AST vlist_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST s = null;
		
			/* type and variable name alternating unless it's void*/
			ArrayList<String> list=new ArrayList();
			ret = null;
		
		
		try {      // for error handling
			AST __t41 = _t;
			AST tmp45_AST_in = (AST)_t;
			match(_t,PARAMS_LIST);
			_t = _t.getFirstChild();
			{
			int _cnt43=0;
			_loop43:
			do {
				if (_t==null) _t=ASTNULL;
				if (((_t.getType() >= ALPHA && _t.getType() <= LITERAL_var))) {
					s = (AST)_t;
					if ( _t==null ) throw new MismatchedTokenException();
					_t = _t.getNextSibling();
					list.add(s.getText());
				}
				else {
					if ( _cnt43>=1 ) { break _loop43; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt43++;
			} while (true);
			}
			_t = __t41;
			_t = _t.getNextSibling();
			
						for(int i = 0; i < list.size(); i++){
							log(list.get(i), DEBUG_FINE);	
						} 
						ret = new String[list.size()]; 
						ret = list.toArray(ret); 
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return ret ;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ALPHA",
		"DIGIT",
		"WS",
		"EOL",
		"COMMENT",
		"LPAREN",
		"RPAREN",
		"MULT",
		"DIV",
		"MOD",
		"PLUS",
		"MINUS",
		"SEMI",
		"LBRACE",
		"RBRACE",
		"ASSIGN",
		"COMMA",
		"EQ",
		"NEQ",
		"GT",
		"GE",
		"LT",
		"LE",
		"AND",
		"OR",
		"ID",
		"DECIMAL",
		"STATEMENT",
		"FUNC_CALL",
		"EXPR_LIST",
		"PARAMS_LIST",
		"FUNC_BODY",
		"\"exit\"",
		"\"bye\"",
		"\"quit\"",
		"\"if\"",
		"\"else\"",
		"\"while\"",
		"\"for\"",
		"\"break\"",
		"\"continue\"",
		"\"return\"",
		"\"pendown\"",
		"\"pd\"",
		"\"penup\"",
		"\"pu\"",
		"\"home\"",
		"\"forward\"",
		"\"fw\"",
		"\"backward\"",
		"\"bw\"",
		"\"right\"",
		"\"rt\"",
		"\"left\"",
		"\"lf\"",
		"\"echo\"",
		"\"clear\"",
		"\"cl\"",
		"\"status\"",
		"\"decimal\"",
		"\"boolean\"",
		"\"void\"",
		"\"funct\"",
		"\"true\"",
		"\"false\"",
		"\"var\""
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 9223370396108650496L, 62L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	}
	
