/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


/**
 *
 * @author ycao
 */
public class VinlBoolean implements VinlType {

	private boolean value;
	private String name=null;

	public VinlBoolean() {
		value = false;
	}
	
	//This is useful for tmp variables that do not have name
	public VinlBoolean(boolean value) {
		this.value=value;
	}

	public VinlBoolean(String name) {
		this.name=name;
	}

	public VinlBoolean(String name, boolean value) {
		this.name = name;
		this.value = value;
	}

	public int getType() {
		return VinlType.BOOLEAN;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public String getName() {
		return this.name;
	}

	public void setValue(boolean value) {
		this.value=value;
	} 

	public boolean getValue() {
		return this.value;
	}

	public VinlType eval(int op, VinlType operand1, VinlType operand2) throws antlr.RecognitionException {
		if (!checkValid(operand1)) {
			throw new antlr.RecognitionException("First operand is not decimal or it has no value");
		}
		if (!checkValid(operand2)) {
			throw new antlr.RecognitionException("Second operand is not decimal or it has no value");
		}
		VinlBoolean op1 = (VinlBoolean) operand1;
		VinlBoolean op2 = (VinlBoolean) operand2;

		/* boolean only supports logical operaionts */
		switch (op) {
			case VinlOperation.OR:
				return op1.or(op2);
			case VinlOperation.AND:
				return op1.and(op2);
			case VinlOperation.EQ:
				return op1.eq(op2);
			case VinlOperation.NEQ:
				return op1.neq(op2);
			default:
				throw new antlr.RecognitionException("Decimal does not support this operation");
		}
	}

	public boolean checkValid(VinlType operand) {
		return (operand.getType() == VinlType.BOOLEAN);
	}

	//logical operations
	public VinlBoolean or(VinlBoolean b) {
		return new VinlBoolean(this.value||b.getValue());
	}

	public VinlBoolean and(VinlBoolean b) {
		return new VinlBoolean(this.value&&b.getValue());
	}

	public VinlBoolean eq(VinlBoolean b) {
		return new VinlBoolean(this.value==b.getValue());
	}
	
	public VinlBoolean neq(VinlBoolean b) {
		return new VinlBoolean(this.value!=b.getValue());
	}
}
